searchNodes=[{"doc":"For example usage please refer to test/examples directory Examples Telemetry event sent to test process defmodule ExampleOneTest do use ExUnit.Case , async : false import TelemetryTest setup [ :telemetry_listen ] @tag telemetry_listen : [ :sample , :event , :example_one ] test &quot;match on telemetry event&quot; do assert :there = ExampleOne . hello ( ) assert_receive { :telemetry_event , %{ event : [ :sample , :event , :example_one ] , measurements : %{ sample_value : :hello_there } , metadata : %{ sample_metadata : true } } } end end Telemetry event being passed to callback after test defmodule ExampleTwoTest do use ExUnit.Case , async : false import TelemetryTest setup [ :telemetry_listen ] @tag telemetry_listen : { [ :sample , :event , :example_two ] , &amp; __MODULE__ . test_callback / 1 } test &quot;match on telemetry event&quot; do assert :there = ExampleTwo . hello ( ) end def test_callback ( telemetry ) do assert %{ event : [ :sample , :event , :example_two ] , measurements : %{ sample_value : :hello_there } , metadata : %{ sample_metadata : true } } = telemetry end end Multiple telemetry events sent to test process defmodule ExampleThreeTest do use ExUnit.Case , async : false import TelemetryTest setup [ :telemetry_listen ] @tag telemetry_listen : [ [ :sample , :event , :example_three , :start ] , [ :sample , :event , :example_three , :stop ] ] test &quot;match on telemetry events&quot; do assert :there = ExampleThree . hello ( ) assert_receive { :telemetry_event , %{ event : [ :sample , :event , :example_three , :start ] , measurements : %{ monotonic_time : _ , system_time : _ } , metadata : %{ sample_metadata : true } } } assert_receive { :telemetry_event , %{ event : [ :sample , :event , :example_three , :stop ] , measurements : %{ monotonic_time : _ , duration : _ } , metadata : %{ more_metadata : true } } } end end Multiple telemetry events being passed to callback after test defmodule ExampleFourTest do use ExUnit.Case , async : false import TelemetryTest setup [ :telemetry_listen ] @tag telemetry_listen : [ { [ :sample , :event , :example_four , :start ] , &amp; __MODULE__ . test_start_callback / 1 } , { [ :sample , :event , :example_four , :stop ] , &amp; __MODULE__ . test_stop_callback / 1 } ] test &quot;match on telemetry events&quot; do assert :there = ExampleFour . hello ( ) end def test_start_callback ( telemetry ) do assert %{ event : [ :sample , :event , :example_four , :start ] , measurements : %{ monotonic_time : _ , system_time : _ } , metadata : %{ sample_metadata : true , telemetry_span_context : _ } } = telemetry end def test_stop_callback ( telemetry ) do assert %{ event : [ :sample , :event , :example_four , :stop ] , measurements : %{ monotonic_time : _ , duration : _ } , metadata : %{ more_metadata : true , telemetry_span_context : _ } } = telemetry end end Multiple telemetry events being passed to callback using MFA defmodule ExampleFourTest do use ExUnit.Case , async : false import TelemetryTest setup [ :telemetry_listen ] @tag telemetry_listen : [ { [ :sample , :event , :example_four , :start ] , &amp; __MODULE__ . test_start_callback / 1 } , { [ :sample , :event , :example_four , :stop ] , &amp; __MODULE__ . test_stop_callback / 1 } ] test &quot;match on telemetry events&quot; do assert :there = ExampleFour . hello ( ) end def test_start_callback ( telemetry ) do assert %{ event : [ :sample , :event , :example_four , :start ] , measurements : %{ monotonic_time : _ , system_time : _ } , metadata : %{ sample_metadata : true , telemetry_span_context : _ } } = telemetry end def test_stop_callback ( telemetry ) do assert %{ event : [ :sample , :event , :example_four , :stop ] , measurements : %{ monotonic_time : _ , duration : _ } , metadata : %{ more_metadata : true , telemetry_span_context : _ } } = telemetry end end","ref":"TelemetryTest.html","title":"TelemetryTest","type":"module"},{"doc":"ExUnit setup callback function which attaches to telemetry events","ref":"TelemetryTest.html#telemetry_listen/1","title":"TelemetryTest.telemetry_listen/1","type":"function"},{"doc":"Telemetry Test is an Elixir library designed to simplify and reduce test clutter when testing Telemetry events. It provides a convenient way to set up Telemetry event listeners, enabling you to write cleaner and more expressive tests for your Telemetry-powered applications.","ref":"readme.html","title":"Telemetry Test","type":"extras"},{"doc":"Telemetry is a powerful framework in Elixir that allows you to instrument your code and collect valuable runtime data. However, when it comes to testing Telemetry events, the process can become verbose and cluttered, leading to complex test code and reduced readability. This library aims to address this challenge by providing a set of utilities that streamline the testing process, making it easier and more enjoyable.","ref":"readme.html#introduction","title":"Telemetry Test - Introduction","type":"extras"},{"doc":"Simplified Event Setup You can set up Telemetry event listeners with just a few lines of code. Instead of manually attaching and detaching event handlers, the library provides functions that handle this process automatically, reducing boilerplate code in your tests. Reduced Test Clutter By abstracting away the setup for Telemetry events, it significantly reduces test clutter. Your test code becomes cleaner, more focused, and easier to understand, improving maintainability and reducing the cognitive load when working with Telemetry-based tests. Multiple Event Listening Options It supports various options for listening to Telemetry events. You can listen for specific events using using the event names, match events with custom callbacks and even listen to multiple events.","ref":"readme.html#key-features","title":"Telemetry Test - Key Features","type":"extras"},{"doc":"To start using the Telemetry Test Helper in your Elixir project, follow these steps: Add the telemetry_test_helper dependency to your mix.exs file: defp deps do [ { :telemetry_test , &quot;~&gt; 1.0&quot; } ] end Run mix deps.get to fetch the new dependency. Ensure that the Telemetry events you want to test are properly instrumented in your application or library. In your test module or TestCase, import the necessary functions from the library: defmodule MyTestModule do use ExUnit.Case , async : false import TelemetryTestHelper end Write your tests by utilizing the library functions. Set up event listeners and perform assertions on received events to validate the behavior of your code. defmodule MyTestModule do use ExUnit.Case , async : false import TelemetryTest setup [ :telemetry_listen ] @tag telemetry_listen : [ :sample , :event , :example_one ] test &quot;match on telemetry event&quot; do # Execute the code that will emit the telemetry event assert :there = ExampleOne . hello ( ) # your test process will receive a message with Telemetry event assert_receive { :telemetry_event , %{ event : [ :sample , :event , :example_one ] , measurements : %{ sample_value : :hello_there } , metadata : %{ sample_metadata : true } } } end end Run your tests with mix test and observe the improved clarity and simplicity in your Telemetry event tests.","ref":"readme.html#getting-started","title":"Telemetry Test - Getting Started","type":"extras"},{"doc":"To help you understand how to use the Telemetry Test, we provide a collection of examples in the Telemetry Test GitHub repository . These examples demonstrate different scenarios and use cases, showcasing the capabilities of the library and providing practical guidance for writing effective Telemetry event tests.","ref":"readme.html#examples","title":"Telemetry Test - Examples","type":"extras"}]